//DESCRIPTION:Скрипт предназаначен для поиска висячих строк, абзацев с одним словом в последней строке, переносов и одно- или двухбуквенных слов в последней строке разворота

// Widow&Orphans#BadHyphenations#LastLines.jsx
// InDesign CS3, CS4, CS5 JavaScript
//
// © Иванюшин М.Ю., 2011 ivanyushin#yandex.ru
// Скрипт предназаначен для поиска:
// - висячих строк, 
// - абзацев с одним словом в последней строке, 
// - абзацев, внутри которых есть строки, начинающиеся с тире, минуса или дефиса,
// - переносов в последней строке разворота (или страницы, если опция 'Facing Pages' неактивна) 
// - последних строк на странице, заканчивающихся одно- или двухбуквенным словом. Поиск в пространстве разворота (или страницы, если опция 'Facing Pages' неактивна)

#target indesign
#targetengine "session"

var myProgramTitul = "  Проверка вёрстки. 25.05.2011  ";
var myInfoLine ="";
var myPageNumbers;
var mySelection = app.selection[0];
var myPages = new Array;
var myShortLines = new Array;
var myBadParagraphs = new Array;
var myPageStrart;
var myPageEnd;

var myDocument = app.documents.item(0);
//  — шаблон цвета для myInfoColor
myColorOfLastWordSample = [0, 100, 100, 0]; 
var myDocIsSpread = true;
//---
// http://forums.adobe.com/message/3152162#3152162
var ProgressBar = function(/*str*/title)
{
     var w = new Window('palette', title, {x:0, y:0, width:440, height:60},{closeButton: false}),	 
     pb = w.add('progressbar', {x:20, y:32, width:400, height:12}, 0, 100),
     st = w.add('statictext', {x:20, y:12, width:400, height:20});
	 st.justify = 'left';
	 w.center();
     this.reset = function(msg,maxValue)
          {
          st.text = msg;
          pb.value = 0;
          pb.maxvalue = maxValue||0;
          pb.visible = !!maxValue;
          w.show();
          };
     this.hit = function() {++pb.value;};
     this.hide = function() {w.hide();};
     this.close = function() {w.close();};
}
//---
/////
var myVersion = app.scriptPreferences.version;
var myVerChar = myVersion.charAt(0);
if (myVerChar < 5) {alert ("Скрипт не работает с этой версией программы.",myProgramTitul); exit();}
if(app.documents.length != 0) { // app.documents.length
	if(app.selection.length != 0) { // app.selection.length
	switch(mySelection.constructor.name) { // mySelection.constructor.name
	case "InsertionPoint":
	 var mySelection = app.selection[0];
	 myStory = mySelection.parentStory;
	if (myStory.overflows == true)  {  
		alert("В текстовой цепочке есть переполнение.",myProgramTitul);	
		exit();
	}  
	if (myStory.textColumns.length == 1) { //FR
		 alert("Нет текстовой цепочки.",myProgramTitul);	
		exit();
		} //FR 
	var mVersion = app.scriptPreferences.version;
	 //цикл по числу колонок статьи. Цикл начинается со второй колонки
	var pBar = new ProgressBar(myProgramTitul);
	pBar.reset(" 1/5 Поиск висячих строк... " , myStory.textColumns.length);
	 for (var myCounter = 1; myCounter < myStory.textColumns.length; myCounter ++, pBar.hit()) { // myStory.textColumns.length		 
		var myCurrentColumn = myStory.textColumns[myCounter]; 
		var myPreviousColumn = myStory.textColumns[myCounter-1];
		if ((myCurrentColumn.characters.length < 3) || (myPreviousColumn.characters.length < 3) ) continue; // на случай, если в цепочке есть пустые фреймы
		var myFirstCharInBottomLine = myPreviousColumn.lines.lastItem().characters[0].index; // индекс первого символа нижней строки предыдущей колонки
		var myFirstCharInTopLine = myCurrentColumn.lines.firstItem().characters[0].index; // индекс первого символа первой строки текущей колонки
		var myLastCharInTopLine = myCurrentColumn.lines.firstItem().characters.lastItem().index; // индекс последнего символа первой строки текущей колонки
		myCurrentColumn.lines.firstItem().characters[0].select();	
		var myP = app.selection[0].paragraphs[0]; // myP -- ссылка на абзац, у которого по крайней мере один символ размещен в первой строке текущего фрейма
		if (myP.length == 1) {
			(myVerChar == 5 || myVersion == 6 ) ? myShortLines.push (myP.parentTextFrames[0].parent.name)  :  myShortLines.push (myP.parentTextFrames[0].parentPage.name);									
		} // номер страницы, в начале которой встречен один знак перевода строки, сохранен в массиве	
		// myParaFirst и myParaLast — индексы первого и последнего символов абзаца myP
		var myParaFirst = myP.characters.firstItem().index;
		var myParaLast = myP.characters.lastItem().index;
		if (myFirstCharInTopLine == myParaFirst)  continue;	// абзац начинается с первой строки текущей колонки
		if (myFirstCharInBottomLine == myParaFirst) { // обнаружена висячая строка внизу полосы
			(myVerChar == 5 || myVersion == 6 ) ? myPages.push (myPreviousColumn.parentTextFrames[0].parent.name)  : myPages.push (myPreviousColumn.parentTextFrames[0].parentPage.name);	
			// номер страницы с этой полосой сохранен в массиве
			} 
		if (myLastCharInTopLine == myParaLast) { // обнаружена висячая строка верху полосы
			(myVerChar == 5 || myVersion == 6 ) ? myPages.push (myCurrentColumn.parentTextFrames[0].parent.name)  : myPages.push (myCurrentColumn.parentTextFrames[0].parentPage.name);			
			// номер страницы с этой полосой сохранен в массиве
			} 
	} //myStory.textColumns.length
try { (myVerChar == 5 || myVersion == 6 ) ? myPageStrart = myStory.textColumns[0].parentTextFrames[0].parent.name : myPageStrart = myStory.textColumns[0].parentTextFrames[0].parentPage.name; }
catch (e) { pBar.close(); alert("Встречен фрейм на рабочем столе.",myProgramTitul); exit(); }
try { (myVerChar == 5 || myVersion == 6 ) ? myPageEnd = myStory.textColumns[myStory.textColumns.length -1].parentTextFrames[0].parent.name : myPageEnd = myStory.textColumns[myStory.textColumns.length -1].parentTextFrames[0].parentPage.name; }
catch (e) { pBar.close(); alert("Встречен фрейм на рабочем столе.",myProgramTitul); exit(); }
if ( myPageStrart != myPageEnd ) { myInfoLine ="Обработаны страницы с " + myPageStrart  +" по " + myPageEnd +".\r";}
else { myInfoLine ="Обработана одна страница " + myPageStrart +".\r" ;}
	if (myPages.length ==0) { 
		myInfoLine+= "\rВисячие строки не обнаружены.";	
		}
	else { 
		myPageNumbers  = myPages.join (', ');	
		myInfoLine+="\rВисячая строка — неполная первая или последняя строка текстового фрейма.   \rТребуют внимания страницы:  " +myPageNumbers + ".";
		} 
/////////////	
	try{
		myColor = myDocument.colors.item("myInfoColor");
		myName = myColor.name;
		}
	catch (myError) {
		myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myColorOfLastWordSample});
		}
	pBar.reset(" 2/5 Поиск абзацев с одним словом в последней строке..." , myStory.paragraphs.length);
	for(var myCounter = 0; myCounter <  myStory.paragraphs.length; myCounter ++, pBar.hit()) { // myStory.paragraphs.length		
		var myPara = myStory.paragraphs[myCounter]; 
		if (myPara.lines.length ==1) 	continue;  // это один абзац из одной строки
		if (myPara.lines[myPara.lines.length-1].words.length == 1) {
			var myLastWordinPara = myPara.lines[myPara.lines.length-1].words[-1];
			myLastWordinPara.fillColor = "myInfoColor";
			var myPageNumber = myGetPage(myLastWordinPara.parentTextFrames[0]);
			myBadParagraphs.push (myPageNumber); // номер страницы, на которой встречена короткая строка, сохранен в массиве
			}
	} // myStory.paragraphs.length
	if (myBadParagraphs.length ==0) { // == 0
		myInfoLine+= "\r\r\r~~~~~~~~~~~~~~~~~~~~\r\Абзацев с одним словом в последней строке не обнаружено.";	
		} // == 0
	else { // else
		myPageNumbers  = myBadParagraphs.join (', ');	
		myInfoLine+="\r\r\r~~~~~~~~~~~~~~~~~~~~\rВстречены абзацы с одним словом в последней строке.\rЭти слова окрашены цветом 'myInfoColor'.\rТребуют внимания страницы:  " +myPageNumbers + ".";
		} // else
///////////
	 //цикл по числу фреймов, содержащих статью в поиске строк, начинающихся с тире
var myTire = new Array;	 
pBar.reset(" 3/5 Поиск внутриабзацных строк, начинающихся с тире..." , myStory.textColumns.length);
for (var myCounter = 0; myCounter <  myStory.textColumns.length; myCounter ++, pBar.hit()) { // myStory.textColumns.length	
	var myCurrentColumn = myStory.textColumns[myCounter];
	var myNumberOfLines=myCurrentColumn.lines;
   //цикл по числу строк в текущем фрейме    
	for (var j=0; j<myNumberOfLines.length; j++){ // myNumberOfLines.length
		var myLine=myCurrentColumn.lines.item(j);
		try  { var myFrstChar = myLine.characters.item(0).contents }
		catch (e) { continue }
		if (( myFrstChar != 1397058884 ) && myFrstChar != 1397059140  && myFrstChar != "-") continue; // 1397058884 - код тире  1397059140 - код минуса
		if (myLine.characters[0] == myLine.paragraphs[0].characters[0]) continue;  // пропускаем случаи, когда строка начинается с тире диалога
		(myVerChar == 5 || myVersion == 6 ) ? myTire.push (myLine.parentTextFrames[0].parent.name)  :  myTire.push (myLine.parentTextFrames[0].parentPage.name);			
		// номер страницы, на которой встречено тире в начале строки, сохранен в массиве
		myLine.characters.item(0).fillColor = "myInfoColor";
		} // myNumberOfLines.length
	} // myStory.textColumns.length
	if (myTire.length ==0) {
		myInfoLine+= "\r\r\r~~~~~~~~~~~~~~~~~~~~\rСтрок в середине абзаца, начинающихся с тире, минуса или дефиса, не обнаружено.";	
		} 
	else { 
		myPageNumbers  = myTire.join (', ');	
		myInfoLine+="\r\r\r~~~~~~~~~~~~~~~~~~~~\rВстречены строки, начинающиеся с тире, минуса или дефиса.\rЭти символы окрашены цветом 'myInfoColor'.\rТребуют внимания страницы:  " +myPageNumbers + ".";
	}
//////////	
var myDash = new Array;	 
var myNumberOfDash = 0;
pBar.reset(" 4/5 Поиск слов с переносом в последней строке страницы..." , myStory.textColumns.length);
//цикл по числу колонок статьи. Движение сверху вниз
	for (myCounter = 0; myCounter < myStory.textColumns.length - 1; myCounter++, pBar.hit()) { // myCounter < myStory.textColumns.length		
	// в цикле в условии окончания 'myStory.textColumns.length - 1' указана '-1', т.к. не надо анализировать перенос в последнем слове последнего фрейма.
	myCurrentColumn = myStory.textColumns[myCounter]; // ссылка на очередную колонку
	myNextColumn = myStory.textColumns[myCounter+1]; // ссылка на следующую  колонку 
	myPageOfCurrColumn = myGetPage(myCurrentColumn.parentTextFrames[0]);
	myPageOfNextColumn = myGetPage(myNextColumn.parentTextFrames[0]);
	if (myPageOfCurrColumn == myPageOfNextColumn) continue; // если колонки на одной странице, повторяем цикл
	if (myDocIsSpread == true) { // myDocIsSpread == true
		if (myPageOfCurrColumn % 2 == 0) { // == 0, если текстовый фрейм на четной, т.е. левой полосе
		continue;
		}  // == 0, если текстовый фрейм на четной, т.е. левой полосе
	} // myDocIsSpread == true
	// В случае многоколонника перед тем, как запрещать перенос последнего слова в колонке, надо убедиться, что это слово действительно последнее на этой странице.
	try { var myLastWordInCurrentColumn = myCurrentColumn.words[-1].contents; } // последнее слово в текущей колонке
	catch (e) { continue; }	
	try { var myFirstWordInNextColumn = myNextColumn.words[0].contents; } // первое слово в следующей колонке
	catch (e) { continue; }
	// если слово переносится, то myLastWordInCurrentColumn и myFirstWordInNextColumn совпадают. Критерий совпадения -- равенство индексов слов в статье.
	var myIndexOfLastWordInCurrentColumn = myCurrentColumn.words[-1].index;
	var myIndexOfFirstWordInNextColumn = myNextColumn.words[0].index;
	if (myIndexOfLastWordInCurrentColumn != myIndexOfFirstWordInNextColumn) continue;
	myDash.push (myPageOfCurrColumn); // номер страницы с переносом в последнем слове помещен в массив myDash
	myNumberOfDash++;
	} // myCounter < myStory.textColumns.length
	if (myNumberOfDash ==0) {
		myInfoLine+= "\r\r\r~~~~~~~~~~~~~~~~~~~~\rПереносов последних слов на развороте не обнаружено.";	
		} 
else { 
		myPageNumbers  = myDash.join (', ');	
		myInfoLine+="\r\r\r~~~~~~~~~~~~~~~~~~~~\rВстречены полосы с переносом в последней строке.\rТребуют внимания страницы:  " +myPageNumbers + ".";
		}
////
var myShortWord = new Array;	 
var myNumberOfShortWords = 0;
pBar.reset(" 5/5 Поиск одно- и двухбуквенных слов в последней строке страницы..." , myStory.textColumns.length);
//цикл по числу колонок статьи. Движение сверху вниз
	for (myCounter = 0; myCounter < myStory.textColumns.length - 1; myCounter++, pBar.hit()) { // myCounter < myStory.textColumns.length		
	// в цикле в условии окончания 'myStory.textColumns.length - 1' указана '-1', т.к. не надо анализировать перенос в последнем слове последнего фрейма.
	myCurrentColumn = myStory.textColumns[myCounter]; // ссылка на очередную колонку
	myNextColumn = myStory.textColumns[myCounter+1]; // ссылка на следующую  колонку 
	myPageOfCurrColumn = myGetPage(myCurrentColumn.parentTextFrames[0]);
	myPageOfNextColumn = myGetPage(myNextColumn.parentTextFrames[0]);
	if (myPageOfCurrColumn == myPageOfNextColumn) continue; // если колонки на одной странице, повторяем цикл
	if (myDocIsSpread == true) { // myDocIsSpread == true
		if (myPageOfCurrColumn % 2 == 0) { // == 0, если текстовый фрейм на четной, т.е. левой полосе
		continue;
		}  // == 0, если текстовый фрейм на четной, т.е. левой полосе
	} // myDocIsSpread == true
	// В случае многоколонника перед тем, как запрещать перенос последнего слова в колонке, надо убедиться, что это слово действительно последнее на этой странице.
	try { var myLastWordInCurrentColumn = myCurrentColumn.words[-1].contents; } // последнее слово в текущей колонке
	catch (e) { continue }
	try { var myFirstWordInNextColumn = myNextColumn.words[0].contents;}  // первое слово в следующей колонке
	catch (e) { continue }
	// если слово переносится, то myLastWordInCurrentColumn и myFirstWordInNextColumn совпадают. Критерий совпадения -- равенство индексов слов в статье.
	var myIndexOfLastWordInCurrentColumn = myCurrentColumn.words[-1].index;
	var myIndexOfFirstWordInNextColumn = myNextColumn.words[0].index;
	if (myIndexOfLastWordInCurrentColumn == myIndexOfFirstWordInNextColumn) continue;
	if (myCurrentColumn.words[-1].length < 3) { // < 3
		myShortWord.push(myPageOfCurrColumn); // номер страницы с коротким последним словом в нижней строке помещен в массив myDash
		myNumberOfShortWords++;
		} // < 3
	} // myCounter < myStory.textColumns.length
	pBar.close();    
	if (myNumberOfShortWords ==0) {
		myInfoLine+= "\r\r\r~~~~~~~~~~~~~~~~~~~~\rОдно- или двухбуквенных слов в нижних строках не обнаружено.";	
		} 
else { 
		myPageNumbers  = myShortWord.join (', ');	
		myInfoLine+="\r\r\r~~~~~~~~~~~~~~~~~~~~\rВстречены одно- или двухбуквенные слова в нижних строках.\rТребуют внимания страницы:  " +myPageNumbers + ".";
		}
myInfoLine+= "\r\r\r~~~~~~~~~~~~~~~~~~~~\r";
var myWindow = new Window ("palette",myProgramTitul);
var myMessage = myWindow.add ("statictext", undefined , myInfoLine,{multiline: true});
myMessage.minimumSize.width = 500;
myMessage.text = myInfoLine;

myBtnOK = myWindow.add ("button", undefined, "Закрыть", {name: "ok"});
myBtnOK.onClick = function ()
{
myWindow.close ();
exit();

}
///-- 
// http://forums.adobe.com/message/3462710#3462710
myWindow.addEventListener('mouseout', leaveTestPalette);
function leaveTestPalette(/*MouseEvent*/mev)
    {
    if( mev.target instanceof Window ) app.activate();
    }
///--
myWindow.show ();
exit();
} // mySelection.constructor.name
} // app.selection.length
alert(" \rПоместите курсор в текст и попробуйте снова.\r",myProgramTitul);	
exit();
} // app.documents.length
alert(" \rНет открытых документов.\r",myProgramTitul);	
exit();
//////////
function myGetPage(myTxtFrame) {
var myCntr = 0;	
var myParentTextFrame;
var myPage;
myParentTextFrame = myTxtFrame;
do {
		if (myCntr == 3) { // Число 3 никакого глубокого смысла не имеет. Оно взято просто с запасом, чтобы программно выйти из ситуации, если встретится случай, когда после трех итераций номер страницы не был определен.
		alert ("Не удалось узнать номер страницы очередного фрейма.\nСкорее всего, он размещен на рабочем столе.");
		exit();
		}
	myCntr++;
	try { ( myVerChar == 5 || myVersion == 6 ) ? myParentTextFrame = myParentTextFrame.parent  :  myParentTextFrame = myParentTextFrame.parentPage }
	catch (e) { return "undefined";} 
	myPage = myParentTextFrame;
}
while ( myPage.constructor.name != "Page" )
return myPage.name;
} // myGetPage
//////////
function myGetNumberOfWordsInProcessedColumns(myText,myCount) {
// узнаем число слов в обработанных колонках	
var myWordCounter = 0;	
for (var i = 0; i < myCount; i++) {
	myWordCounter += myText.textColumns[i].words.length;
	}
return myWordCounter;
}	
	
